//
//
//

#include <stdio.h>
#include "cbr.h"

int main() {
    unsigned int num_cols = 7;
    char * cols[] = {
        "BER", "throughput",
        "mod_scheme", "tx_power",
        "noise_power", "path_loss",
        "utility"
    };
    float vals[num_cols];
    vals[0] = 1e-3f;    // BER
    vals[1] = 10e3f;    // throughput
    vals[2] = 1;        // mod_scheme
    vals[3] = -3.0f;    // tx_power
    vals[4] = -50.0f;   // noise_power
    vals[5] = 125.0f;   // path_loss
    vals[6] = 0.762;    // utility
    int rc;

    // create cbr database/table
    cbr mycbr = cbr_create("ex1", "data", cols, num_cols);

    // add row here
    rc = cbr_add_row(mycbr, cols, vals, num_cols);

    // print
    cbr_print(mycbr);

    // simple search: find entry where...
    //   BER < 1e-2 and path_loss > 100
    char * search_names[] = {"BER", "path_loss"};
    int search_ops[] = {LT, GT};
    float search_vals[] = {1e-2f, 100.f};
    float retvals[num_cols];
    rc = cbr_search(mycbr, search_names, search_ops, search_vals, 2, retvals);

    // clean up
    cbr_free(mycbr);

    printf("done.\n");
    return 0;
}

